SystemOrganization addCategory: #'Metacello-TestsProfStef'!

TestCase subclass: #MetacelloInsideToolBoxTutorialTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-TestsProfStef'!

!MetacelloInsideToolBoxTutorialTests classSide methodsFor: 'examples' stamp: 'dkh 3/7/2012 17:08:21'!
EXAMPLE
	"At the moment these guys match up with the code in the ProfStef toolbox tutorial"
	
	self example1. "create baseline version 1.0-baseline"
	self example2. "open version 1.0 for development"
	self example3. "update package specs and description in version 1.0"
	self example4. "release versionn 1.0"
	self example5. "open version 1.1 for development"
	self example6. "add new baseline version 1.1 with #pharo section, update version 1.1 dev method"
	self example7. "release version 1.1 on pharo only"
! !

!MetacelloInsideToolBoxTutorialTests classSide methodsFor: 'examples' stamp: 'dkh 3/7/2012 17:08:21'!
example1
	"create baseline version 1.0-baseline"

	"self example1"

	(MetacelloToolBox configurationNamed: 'Example')
		createVersionMethod: 'baseline10:' inCategory: 'baselines' forVersion: '1.0-baseline';
		addSection: #common
			repository: 'http://www.squeaksource.com/ProfStef'
			requiredProjects: #('Shout')
			packages: #('ProfStef-Core' 'ProfStef-Tests')
			dependencies:
				{('ProfStef-Core' -> #('Shout')).
				('ProfStef-Tests' -> #('ProfStef-Core'))}
			groups:
				{('default' -> #('Core')).
				('Core' -> #('ProfStef-Core')).
				('Tests' -> #('ProfStef-Tests')).
				('Core Tests' -> #('Core' 'Tests'))}
			versionSpecsDo: [ :versionSpec | versionSpec blessing: #baseline ];
		commitMethod! !

!MetacelloInsideToolBoxTutorialTests classSide methodsFor: 'examples' stamp: 'dkh 3/7/2012 17:08:21'!
example2
	"open version 1.0 for development"

	"self example2"

	| message |
	message := '- fixed a bug'.
	(MetacelloToolBox configurationNamed: 'Example')
		createVersionMethod: 'version10:' inCategory: 'versions' forVersion: '1.0';
		importFrom: '1.0-baseline'
			updateProjects: true
			updatePackages: true
			versionSpecsDo: [ :attribute :versionSpec | 
				attribute == #common
					ifTrue: [ 
						"update the author, blessing and timeStamp"
						versionSpec
							author: MetacelloPlatform current authorName;
							blessing: #development;
							description: message;
							timestamp: MetacelloPlatform current timestamp ].
				true ];
		commitMethod;
		symbolicVersionMethod: #development;
		addSymbolicSection: #common version: '1.0';
		commitMethod! !

!MetacelloInsideToolBoxTutorialTests classSide methodsFor: 'examples' stamp: 'dkh 3/7/2012 17:08:21'!
example3
	"update package specs and description in version 1.0"

	"self example3"

	| message |
	message := '- fixed a bug'.
	(MetacelloToolBox configurationNamed: 'Example')
		updateVersionMethodForVersion: '1.0'
			versionSpecsDo: [ :attribute :versionSpec | 
					attribute == #common
						ifTrue: [ 
							"update the author, blessing and timeStamp"
							versionSpec
								author: MetacelloPlatform current authorName;
								timestamp: MetacelloPlatform current timestamp.
							versionSpec description value isEmpty
								ifTrue: [ versionSpec description: message ]
								ifFalse: [ 
									| strm |
									strm := WriteStream on: String new.
									strm
										nextPutAll: versionSpec description value;
										cr;
										nextPutAll: message.
									versionSpec description: strm contents ] ].
					true ];
		commitMethod! !

!MetacelloInsideToolBoxTutorialTests classSide methodsFor: 'examples' stamp: 'dkh 3/7/2012 17:08:21'!
example4
	"release version 1.0"

	"self example4"

	(MetacelloToolBox configurationNamed: 'Example')
		modifyVersionMethodForVersion: '1.0'
			versionSpecsDo: [ :attribute :versionSpec | 
					attribute == #common
						ifTrue: [ versionSpec blessing: #release ].
					true ];
		commitMethod;
		modifySymbolicVersionMethodFor: #development
			symbolicVersionSpecsDo: [ :symbolicVersionSpec | symbolicVersionSpec versionString ~= '1.0' ];
		commitMethod;
		symbolicVersionMethod: #stable;
		addSymbolicSection: #common version: '1.0';
		commitMethod! !

!MetacelloInsideToolBoxTutorialTests classSide methodsFor: 'examples' stamp: 'dkh 3/7/2012 17:08:21'!
example5
	"open version 1.1 for development"

	"self example5"

	| message |
	message := ''.
	(MetacelloToolBox configurationNamed: 'Example')
		createVersionMethod: 'version11:' inCategory: 'versions' forVersion: '1.1';
		addSectionsFrom: '1.0'
			forBaseline: false
			updateProjects: true
			updatePackages: true
			versionSpecsDo: [ :attribute :versionSpec | 
				attribute == #common
					ifTrue: [ 
						"update the author, blessing and timeStamp"
						versionSpec
							author: MetacelloPlatform current authorName;
							description: message;
							blessing: #development;
							timestamp: MetacelloPlatform current timestamp ].
				true ];
		commitMethod;
		modifySymbolicVersionMethodFor: #development symbolicVersionSpecsDo: [ :symbolicVersionSpec | true ];
		addSymbolicSection: #common version: '1.1';
		commitMethod! !

!MetacelloInsideToolBoxTutorialTests classSide methodsFor: 'examples' stamp: 'dkh 3/7/2012 17:08:21'!
example6
	"add new baseline version 1.1 with #pharo section, update version 1.1 dev method"

	"self example6"

	| message |
	message := ''.
	(MetacelloToolBox configurationNamed: 'Example')
		createVersionMethod: 'baseline11:' inCategory: 'baselines' forVersion: '1.1-baseline';
		addSectionsFrom: '1.0-baseline'
			forBaseline: true
			updateProjects: false
			updatePackages: false
			versionSpecsDo: [ :attribute :versionSpec | true ];
		addSection: #pharo
			repository: nil
			requiredProjects: #()
			packages: #('ProfStefBrowser')
			dependencies: {('ProfStefBrowser' -> #('ProfStef-Core'))}
			groups: {('UI' -> #('ProfStefBrowser'))}
			versionSpecsDo: [ :versionSpec |  ];
		commitMethod;
		modifyVersionMethodForVersion: '1.1' versionSpecsDo: [ :attribute :versionSpec | false ];
		importFrom: '1.1-baseline'
			updateProjects: true
			updatePackages: true
			versionSpecsDo: [ :attribute :versionSpec | 
				attribute == #common
					ifTrue: [ 
						"update the author, blessing and timeStamp"
						versionSpec
							author: MetacelloPlatform current authorName;
							blessing: #development;
							description: message;
							timestamp: MetacelloPlatform current timestamp ].
				true ];
		commitMethod;
		modifySymbolicVersionMethodFor: #development symbolicVersionSpecsDo: [ :symbolicVersionSpec | true ];
		addSymbolicSection: #pharo version: '1.1';
		commitMethod! !

!MetacelloInsideToolBoxTutorialTests classSide methodsFor: 'examples' stamp: 'dkh 3/7/2012 17:08:21'!
example7
    "release version 1.1 on pharo only"

    "self example7"

    (MetacelloToolBox configurationNamed: 'Example')
        modifyVersionMethodForVersion: '1.1'
            versionSpecsDo: [ :attribute :versionSpec | 
                    attribute == #'pharo'
                        ifTrue: [ versionSpec blessing: #'release' ].
                    true ];
        commitMethod;
        modifySymbolicVersionMethodFor: #'development'
            symbolicVersionSpecsDo: [ :symbolicVersionSpec | (symbolicVersionSpec attributes includes: #'pharo') not ];
        commitMethod;
        modifySymbolicVersionMethodFor: #'stable' symbolicVersionSpecsDo: [ :symbolicVersionSpec | true ];
        addSymbolicSection: #'pharo' version: '1.1';
        commitMethod! !

!MetacelloInsideToolBoxTutorialTests methodsFor: 'running' stamp: 'DaleHenrichs 12/17/2010 15:29'!
setUp
	super setUp.
	Smalltalk at: #ConfigurationOfExample ifPresent: [:cl | cl removeFromSystem ]
! !

!MetacelloInsideToolBoxTutorialTests methodsFor: 'running' stamp: 'DaleHenrichs 12/17/2010 15:29'!
tearDown
	super tearDown.
	Smalltalk at: #ConfigurationOfExample ifPresent: [:cl | cl removeFromSystem ]
! !

!MetacelloInsideToolBoxTutorialTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/17/2010 15:29'!
testExamples
	"right now just make sure that things don't fail"
	
	self class EXAMPLE! !
